<template>
  <page>
    <a-form
      class="notificacao-form"
      @submit="handleSubmit"
    >
      <h1>Preencha os dados do serviço</h1>
      <a-form-item
        label="Descrição do serviço"
        class="input-icon"
        required="true"
      >
        <a-textarea
          v-model="message"
          placeholder="Digite aqui sua mensagem"
          :rows="6"
          :maxlength="messageLimit"
        />
        <p>{{ messageLimit - message.length }} caracteres restantes</p>
      </a-form-item>

      <a-form-item
        label="Foto demonstrando o serviço"
        class="input-icon"
        required="true"
      >
        <a-upload-dragger
          :file-list="fileList"
          :remove="handleRemove"
          :before-upload="beforeUpload"
        >
          <p class="ant-upload-drag-icon">
            <a-icon type="inbox" />
          </p>
          <p class="ant-upload-text">
            Clique ou arraste a foto para essa área
          </p>
        </a-upload-dragger>
      </a-form-item>

      <a-form-item>
        <a-button
          html-type="submit"
          type="primary"
          class="submit-button"
          :disabled="uploading"
        >
          <span v-if="uploading">
            <a-icon type="loading" />
          </span>
          <span v-else>Enviar</span>
        </a-button>
      </a-form-item>
    </a-form>
  </page>
</template>

<script>
import uploadDragger from '@/mixins/upload-dragger';

export default {
  name: 'AddServices',
  mixins: [uploadDragger],
  data() {
    return {
      message: '',
      messageLimit: 235,
      uploading: false,
    };
  },
  methods: {
    async handleSubmit(e) {
      e.preventDefault();

      if (this.checkFields()) {
        try {
          this.uploading = true;

          const formData = this.createFormData();
          await this.$http.post('/subheaders', formData);

          this.$message.success('Serviço adicionado com sucesso.');

          this.clearFields();
          this.uploading = false;
        } catch (error) {
          this.uploading = false;
          this.$message.error('Ocorreu um erro ao tentar adicionar o serviço. Tente novamente mais tarde.');
        }
      } else {
        this.$message.error('Por favor preencha todos os campos obrigatórios!');
      }
    },
    checkFields() {
      return this.message && this.checkFileList();
    },
    createFormData() {
      const formData = new FormData();

      formData.append('image', this.fileList[0]);
      formData.append('text', this.message);

      return formData;
    },
    clearFields() {
      this.message = '';
      this.fileList = [];
    },
  },
};
</script>

<style lang="stylus" scoped>
.submit-button
  float right
</style>
